## shiboken 1.0.0-1maemo2~beta2

=== CMakeLists.txt ===
include(icecc.cmake)
project(shiboken)

cmake_minimum_required(VERSION 2.6)

set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake/Modules/
                      ${CMAKE_MODULE_PATH})

find_package(Qt4 4.5.0)
find_package(ApiExtractor 0.9.0)
find_package(GeneratorRunner 0.6.3)
find_package(PythonLibs)
find_package(PythonInterpWithDebug)

add_definitions(${QT_DEFINITIONS})

set(shiboken_MAJOR_VERSION "1")
set(shiboken_MINOR_VERSION "0")
set(shiboken_MICRO_VERSION "0")
set(shiboken_VERSION "${shiboken_MAJOR_VERSION}.${shiboken_MINOR_VERSION}.${shiboken_MICRO_VERSION}")

option(AVOID_PROTECTED_HACK "Avoid protected hack on generated bindings." FALSE)
option(BUILD_TESTS "Build tests." TRUE)

if(MSVC)
    set(CMAKE_CXX_FLAGS "/Zc:wchar_t- /GR /EHsc /DWIN32 /D_WINDOWS /D_SCL_SECURE_NO_WARNINGS")
else()
    if(CMAKE_HOST_UNIX)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -fvisibility=hidden -Wno-strict-aliasing")
    endif()
    set(CMAKE_CXX_FLAGS_DEBUG "-g")
    option(ENABLE_GCC_OPTIMIZATION "Enable specific GCC flags to optimization library size and performance. Only available on Release Mode" 0)
    if(ENABLE_GCC_OPTIMIZATION)
        set(CMAKE_BUILD_TYPE Release)
        set(CMAKE_CXX_FLAGS_RELEASE "-DNDEBUG -Os -Wl,-O1")
        if(NOT CMAKE_HOST_APPLE)
            set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wl,--hash-style=gnu")
        endif()
    endif()
endif()

set(LIB_SUFFIX "" CACHE STRING "Define suffix of directory name (32/64)" )
set(LIB_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX}" CACHE PATH "The subdirectory relative to the install prefix where libraries will be installed (default is /lib${LIB_SUFFIX})" FORCE)

if (WIN32)
    set(PATH_SEP "\;")
else()
    set(PATH_SEP ":")
endif()

if(WIN32 OR AVOID_PROTECTED_HACK)
    message(STATUS "Avoiding protected hack!")
    add_definitions("-DAVOID_PROTECTED_HACK")
    set(AVOID_PROTECTED_HACK ON)
else()
    message(STATUS "Using protected hack!")
endif()

# uninstall target
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake"
               "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
               IMMEDIATE @ONLY)
add_custom_target(uninstall "${CMAKE_COMMAND}"
                  -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")

# Detect if the python libs were compiled in debug mode
execute_process(
    COMMAND ${PYTHON_EXECUTABLE} -c "from distutils import sysconfig; \\
        print sysconfig.get_config_var('Py_DEBUG')"
    OUTPUT_VARIABLE PY_DEBUG
    OUTPUT_STRIP_TRAILING_WHITESPACE)

set(SHIBOKEN_BUILD_TYPE "Release")
if(CMAKE_BUILD_TYPE STREQUAL "Debug")
    if(NOT PYTHON_DEBUG_LIBRARIES)
        message(FATAL_ERROR "Python debug library not found. Try compile shiboken with -DCMAKE_BUILD_TYPE=Release")
    endif()
    if(NOT PY_DEBUG)
        message(WARNING "Compiling shiboken with debug enabled, but the python executable was not compiled with debug support.")
    else()
        add_definitions("-DPy_DEBUG")
        set(SBK_ADD_PY_DEBUG_DEFINITION "add_definitions(\"-DPy_DEBUG\")")
        set(SBK_PKG_CONFIG_PY_DEBUG_DEFINITION " -DPy_DEBUG")
    endif()
    set(SBK_PYTHON_LIBRARIES ${PYTHON_DEBUG_LIBRARIES})
    set(SHIBOKEN_BUILD_TYPE "Debug")
else()
    set(SBK_PYTHON_LIBRARIES ${PYTHON_LIBRARIES})
    add_definitions("-DNDEBUG")
endif()
if(APPLE)
    set(SBK_PYTHON_LIBRARIES "-undefined dynamic_lookup")
endif()

if (BUILD_TESTS)
    enable_testing()
endif()

add_subdirectory(libshiboken)
add_subdirectory(doc)

# deps found, compile the generator.
if (QT4_FOUND AND ApiExtractor_FOUND AND GeneratorRunner_FOUND AND PYTHONLIBS_FOUND AND PYTHONINTERP_FOUND)
    add_subdirectory(generator)

    if (BUILD_TESTS)
        add_subdirectory(tests)
    endif()
else()
    message("!! Some dependencies were not found, shiboken generator compilation disabled!")
endif()

if(CMAKE_VERSION VERSION_LESS 2.8)
    set(SBK_PYTHON_INCLUDE_DIR ${PYTHON_INCLUDE_PATH})
else()
    set(SBK_PYTHON_INCLUDE_DIR ${PYTHON_INCLUDE_DIRS})
endif()
add_subdirectory(data)

set(ARCHIVE_NAME ${CMAKE_PROJECT_NAME}-${shiboken_VERSION})
add_custom_target(dist
    COMMAND mkdir -p "${CMAKE_BINARY_DIR}/${ARCHIVE_NAME}" &&
            git log > "${CMAKE_BINARY_DIR}/${ARCHIVE_NAME}/ChangeLog" &&
            git archive --prefix=${ARCHIVE_NAME}/ HEAD --format=tar --output="${CMAKE_BINARY_DIR}/${ARCHIVE_NAME}.tar" &&
            tar -C "${CMAKE_BINARY_DIR}" --owner=root --group=root -r "${ARCHIVE_NAME}/ChangeLog" -f "${CMAKE_BINARY_DIR}/${ARCHIVE_NAME}.tar" &&
            bzip2 -f9 "${CMAKE_BINARY_DIR}/${ARCHIVE_NAME}.tar" &&
            echo "Source package created at ${CMAKE_BINARY_DIR}/${ARCHIVE_NAME}.tar.bz2.\n"
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})

=== tests/libsample/CMakeLists.txt ===
project(libsample)

set(libsample_SRC
abstract.cpp
blackbox.cpp
bucket.cpp
collector.cpp
complex.cpp
derived.cpp
echo.cpp
functions.cpp
implicitconv.cpp
injectcode.cpp
listuser.cpp
modifications.cpp
mapuser.cpp
modified_constructor.cpp
multiple_derived.cpp
objectmodel.cpp
objecttype.cpp
objecttypelayout.cpp
objectview.cpp
overload.cpp
overloadsort.cpp
pairuser.cpp
point.cpp
pointf.cpp
polygon.cpp
protected.cpp
reference.cpp
samplenamespace.cpp
simplefile.cpp
size.cpp
sometime.cpp
str.cpp
strlist.cpp
virtualmethods.cpp
expression.cpp
)

include_directories(${CMAKE_CURRENT_SOURCE_DIR})
add_definitions("-DLIBSAMPLE_BUILD")
add_library(libsample SHARED ${libsample_SRC})
set_property(TARGET libsample PROPERTY PREFIX "")

=== tests/samplebinding/CMakeLists.txt ===
project(sample)

set(sample_TYPESYSTEM
${CMAKE_CURRENT_SOURCE_DIR}/typesystem_sample.xml
)

set(sample_SRC
${CMAKE_CURRENT_BINARY_DIR}/sample/abstractmodifications_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/abstract_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/base1_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/base2_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/base3_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/base4_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/base5_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/base6_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/blackbox_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/bucket_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/collector_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/ctorconvrule_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/sbkdate_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/derived_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/derived_someinnerclass_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/echo_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/event_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/expression_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/handleholder_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/implicitconv_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/implicitbase_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/implicittarget_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/intlist_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/sortedoverload_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/intwrapper_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/injectcode_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/listuser_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/mapuser_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/mderived1_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/mderived2_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/mderived3_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/mderived4_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/mderived5_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/modifications_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/modifiedconstructor_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/noimplicitconversion_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/nondefaultctor_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/objectmodel_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/objecttype_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/objecttypelayout_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/objectview_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/objtypereference_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/oddbooluser_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/overload_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/pairuser_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/point_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/pointf_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/pointerholder_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/polygon_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/privatector_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/privatedtor_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/protectedenumclass_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/protectednonpolymorphic_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/protectedpolymorphic_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/protectedpolymorphicdaughter_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/protectedpolymorphicgranddaughter_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/protectedproperty_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/protectedvirtualdestructor_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/reference_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/sample_module_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/samplenamespace_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/samplenamespace_someclass_someinnerclass_okthisisrecursiveenough_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/samplenamespace_someclass_someinnerclass_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/samplenamespace_someclass_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/samplenamespace_derivedfromnamespace_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/simplefile_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/size_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/sonofmderived1_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/str_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/strlist_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/time_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/virtualdaughter_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/virtualdtor_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/virtualmethods_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/voidholder_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/sample/valueandvirtual_wrapper.cpp
)

add_custom_command(OUTPUT ${sample_SRC}
COMMAND ${GENERATORRUNNER_BINARY} --generatorSet=${generators_BINARY_DIR}/shiboken_generator${CMAKE_RELEASE_POSTFIX}${CMAKE_DEBUG_POSTFIX} --enable-parent-ctor-heuristic
        ${CMAKE_CURRENT_SOURCE_DIR}/global.h
        --include-paths=${libsample_SOURCE_DIR}
        --typesystem-paths=${CMAKE_CURRENT_SOURCE_DIR}
        --output-directory=${CMAKE_CURRENT_BINARY_DIR}
        ${sample_TYPESYSTEM}
WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
COMMENT "Running generator for test binding..."
)

include_directories(${CMAKE_CURRENT_SOURCE_DIR}
                    ${CMAKE_SOURCE_DIR}
                    ${PYTHON_INCLUDE_PATH}
                    ${libsample_SOURCE_DIR}
                    ${libshiboken_SOURCE_DIR})
add_library(sample MODULE ${sample_SRC})
set_property(TARGET sample PROPERTY PREFIX "")
if(WIN32)
    set_property(TARGET sample PROPERTY SUFFIX ".pyd")
endif()
target_link_libraries(sample
                      libsample
                      ${SBK_PYTHON_LIBRARIES}
                      libshiboken)

add_dependencies(sample shiboken_generator)

=== debian/changelog ===
shiboken (1.0.0-1maemo2~beta2) unstable; urgency=low

  * Imported beta2 version from PPA. (1.0.0~beta1-0pyside2~maverick0)
    + Fixes debug package.

 -- Lauro Moura <lauro.neto@openbossa.org>  Wed, 22 Dec 2010 19:52:01 -0300

=== debian/rules ===
#!/usr/bin/make -f

# Allow to find debhelper7 on Maemo
PATH := /usr/bin/dh7:$(PATH)
export PATH

%:
	dh --with quilt --buildsystem=cmake --parallel $@

# Python versions (default is first)
PYVERSIONS=$(shell pyversions -v -r)
DEFAULT_PY=$(shell pyversions -v -d)

#### CONFIGURE ####

override_dh_auto_configure: $(PYVERSIONS:%=override_dh_auto_configure_dbg-%) $(PYVERSIONS:%=override_dh_auto_configure-%)

override_dh_auto_configure_dbg-%:
	mkdir -p build-$*-dbg
	dh_auto_configure --builddirectory=build-$*-dbg -- \
	-DCMAKE_BUILD_TYPE:STRING="Debug" \
	-DCMAKE_SKIP_RPATH=true \
	-DCMAKE_USE_PYTHON_VERSION="$*-dbg;$*_d;$*" \
	-DCMAKE_DEBUG_POSTFIX=$(shell echo -py$*_d | sed -e 's/\.//g' -)

override_dh_auto_configure-%:
	mkdir -p build-$*
	dh_auto_configure --builddirectory=build-$* -- \
	-DCMAKE_BUILD_TYPE:STRING="Release" \
	-DCMAKE_SKIP_RPATH=true \
	-DCMAKE_USE_PYTHON_VERSION=$* \
	-DDEFAULT_SHIBOKEN_POSTFIX=$(shell echo -py${DEFAULT_PY} | sed -e 's/\.//g' -) \
	-DCMAKE_RELEASE_POSTFIX=$(shell echo -py$* | sed -e 's/\.//g' -)

#### BUILD ####

override_dh_auto_build: $(PYVERSIONS:%=override_dh_auto_build_dbg-%) $(PYVERSIONS:%=override_dh_auto_build-%)

override_dh_auto_build_dbg-%:
	dh_auto_build --builddirectory=build-$*-dbg

override_dh_auto_build-%:
	dh_auto_build --builddirectory=build-$*

override_dh_compress:
	dh_compress -X.js

#### INSTALL ####

override_dh_auto_install: $(PYVERSIONS:%=override_dh_auto_install_dbg-%) $(PYVERSIONS:%=override_dh_auto_install-%)

override_dh_auto_install_dbg-%:
	dh_auto_install --builddirectory=build-$*-dbg --destdir=debian/tmp-dbg

override_dh_auto_install-%:
	dh_auto_install --builddirectory=build-$*

#### STRIP ####
override_dh_strip:
	dh_strip --dbg-package=shiboken-dbg --exclude=_d.so

#### TEST ####

override_dh_auto_test: $(PYVERSIONS:%=override_dh_auto_test_dbg-%) $(PYVERSIONS:%=override_dh_auto_test-%)

override_dh_auto_test_dbg-%: prepare_debug_test-%
	- dh_auto_test --builddirectory=build-$*-dbg

override_dh_auto_test-%: prepare_test-%
	dh_auto_test --builddirectory=build-$*

prepare_debug_test-%:
	# Prepare the convenience symlinks for the tests
	$(shell ln -s libother`echo -py$* | sed -e 's/\.//g' -`_d.so \
	   build-$*-dbg/tests/libother/libother.so )
	$(shell ln -s libsample`echo -py$* | sed -e 's/\.//g' -`_d.so \
	   build-$*-dbg/tests/libsample/libsample.so )
	$(shell ln -s other`echo -py$* | sed -e 's/\.//g' -`_d.so \
	   build-$*-dbg/tests/otherbinding/other.so )
	$(shell ln -s sample`echo -py$* | sed -e 's/\.//g' -`_d.so \
	   build-$*-dbg/tests/samplebinding/sample.so )

prepare_test-%:
	# Prepare the convenience symlinks for the tests
	$(shell ln -s libother`echo -py$* | sed -e 's/\.//g' -`.so \
	   build-$*/tests/libother/libother.so )
	$(shell ln -s libsample`echo -py$* | sed -e 's/\.//g' -`.so \
	   build-$*/tests/libsample/libsample.so )
	$(shell ln -s other`echo -py$* | sed -e 's/\.//g' -`.so \
	   build-$*/tests/otherbinding/other.so )
	$(shell ln -s sample`echo -py$* | sed -e 's/\.//g' -`.so \
	   build-$*/tests/samplebinding/sample.so )

#### CLEAN ####
override_dh_auto_clean:
	rm -rf build-*
	rm -rf debian/tmp-dbg

#### DEBIAN INSTALL ####

override_dh_install: override_dh_install_done

override_dh_install_real:
	# Install the debug variant
	dh_install --sourcedir=debian/tmp-dbg -pshiboken-dbg
	
	# Install the other variants
	dh_install --list-missing --remaining-packages

override_dh_install_done: override_dh_install_real
	# Setup the default version symbolic links
	$(shell ln -sf shiboken_generator`echo -py${DEFAULT_PY} | sed -e 's/\.//g' -`.so \
	               debian/shiboken/usr/lib/generatorrunner/shiboken_generator.so )
	$(shell ln -sf libshiboken`echo -py${DEFAULT_PY} | sed -e 's/\.//g' -`.so \
	               debian/libshiboken-dev/usr/lib/libshiboken.so )
	# Setup the debug default version symbolic links
	$(shell ln -sf shiboken_generator`echo -py${DEFAULT_PY} | sed -e 's/\.//g' -`_d.so \
	               debian/shiboken-dbg/usr/lib/generatorrunner/shiboken_generator_d.so )
	$(shell ln -sf libshiboken`echo -py${DEFAULT_PY} | sed -e 's/\.//g' -`_d.so \
	               debian/shiboken-dbg/usr/lib/libshiboken_d.so )

#### Shared libs ####
override_dh_makeshlibs:
	# Package shiboken ships a usr/lib/generatorrunner/*.so plugin. No shared libs in there.
	dh_makeshlibs -Nshiboken

#### Docs ####
binary: binary-arch binary-indep;

binary-indep: binary-arch
	dh binary-indep --until dh_auto_build
	dh_auto_build -i --builddirectory=build-$(DEFAULT_PY) -- doc
	dh binary-indep --after dh_auto_build

## shiboken 1.0.0-2maemo1~beta3

=== CMakeLists.txt ===
--- 
+++ 
@@ -66,7 +66,7 @@
 # Detect if the python libs were compiled in debug mode
 execute_process(
     COMMAND ${PYTHON_EXECUTABLE} -c "from distutils import sysconfig; \\
-        print sysconfig.get_config_var('Py_DEBUG')"
+        print bool(sysconfig.get_config_var('Py_DEBUG'))"
     OUTPUT_VARIABLE PY_DEBUG
     OUTPUT_STRIP_TRAILING_WHITESPACE)
 
@@ -92,10 +92,6 @@
     set(SBK_PYTHON_LIBRARIES "-undefined dynamic_lookup")
 endif()
 
-if (BUILD_TESTS)
-    enable_testing()
-endif()
-
 add_subdirectory(libshiboken)
 add_subdirectory(doc)
 
@@ -104,10 +100,11 @@
     add_subdirectory(generator)
 
     if (BUILD_TESTS)
+        enable_testing()
         add_subdirectory(tests)
     endif()
 else()
-    message("!! Some dependencies were not found, shiboken generator compilation disabled!")
+    message(WARNING "Some dependencies were not found, shiboken generator compilation disabled!")
 endif()
 
 if(CMAKE_VERSION VERSION_LESS 2.8)
@@ -115,8 +112,10 @@
 else()
     set(SBK_PYTHON_INCLUDE_DIR ${PYTHON_INCLUDE_DIRS})
 endif()
+
 add_subdirectory(data)
 
+# dist target
 set(ARCHIVE_NAME ${CMAKE_PROJECT_NAME}-${shiboken_VERSION})
 add_custom_target(dist
     COMMAND mkdir -p "${CMAKE_BINARY_DIR}/${ARCHIVE_NAME}" &&

=== libshiboken/CMakeLists.txt ===
project(libshiboken)

option(ENABLE_VERSION_SUFFIX "Used to use current version in suffix to generated files. This is used to allow multiples versions installed simultaneous." FALSE)
if(ENABLE_VERSION_SUFFIX)
    set(shiboken_SUFFIX "-${shiboken_MAJOR_VERSION}.${shiboken_MINOR_VERSION}")
else()
    set(shiboken_SUFFIX "")
endif()

#Find installed sparsehash
find_path(SPARSEHASH_INCLUDE_PATH sparseconfig.h PATH_SUFFIXES "/google/sparsehash")
if(SPARSEHASH_INCLUDE_PATH)
    message(STATUS "Using system hash found in: ${SPARSEHASH_INCLUDE_PATH}")
else()
    set(SPARSEHASH_INCLUDE_PATH ${CMAKE_SOURCE_DIR}/ext/sparsehash)
endif()

set(libshiboken_MAJOR_VERSION ${shiboken_MAJOR_VERSION})
set(libshiboken_MINOR_VERSION ${shiboken_MINOR_VERSION})
set(libshiboken_MICRO_VERSION ${shiboken_MICRO_VERSION})
set(libshiboken_VERSION "${libshiboken_MAJOR_VERSION}.${libshiboken_MINOR_VERSION}.${libshiboken_MICRO_VERSION}")
set(libshiboken_SOVERSION "${libshiboken_MAJOR_VERSION}.${libshiboken_MINOR_VERSION}")

set(libshiboken_SRC
basewrapper.cpp
gilstate.cpp
helper.cpp
sbkenum.cpp
bindingmanager.cpp
threadstatesaver.cpp
typeresolver.cpp
)

include_directories(${CMAKE_CURRENT_SOURCE_DIR}
                    ${PYTHON_INCLUDE_PATH}
                    ${SPARSEHASH_INCLUDE_PATH})
add_library(libshiboken SHARED ${libshiboken_SRC})
target_link_libraries(libshiboken ${SBK_PYTHON_LIBRARIES})
set_target_properties(libshiboken PROPERTIES OUTPUT_NAME "shiboken${shiboken_SUFFIX}"
                                             VERSION ${libshiboken_VERSION}
                                             SOVERSION ${libshiboken_SOVERSION}
                                             DEFINE_SYMBOL LIBSHIBOKEN_EXPORTS)

install(FILES
        autodecref.h
        basewrapper.h
        bindingmanager.h
        conversions.h
        gilstate.h
        helper.h
        sbkenum.h
        python25compat.h
        sbkdbg.h
        shiboken.h
        shibokenmacros.h
        threadstatesaver.h
        typeresolver.h
        DESTINATION include/shiboken${shiboken_SUFFIX})
install(TARGETS libshiboken EXPORT shiboken
                            LIBRARY DESTINATION "${LIB_INSTALL_DIR}"
                            ARCHIVE DESTINATION "${LIB_INSTALL_DIR}"
                            RUNTIME DESTINATION bin)

=== tests/samplebinding/CMakeLists.txt ===
--- 
+++ 
@@ -45,6 +45,7 @@
 ${CMAKE_CURRENT_BINARY_DIR}/sample/objectmodel_wrapper.cpp
 ${CMAKE_CURRENT_BINARY_DIR}/sample/objecttype_wrapper.cpp
 ${CMAKE_CURRENT_BINARY_DIR}/sample/objecttypelayout_wrapper.cpp
+${CMAKE_CURRENT_BINARY_DIR}/sample/objecttypeoperators_wrapper.cpp
 ${CMAKE_CURRENT_BINARY_DIR}/sample/objectview_wrapper.cpp
 ${CMAKE_CURRENT_BINARY_DIR}/sample/objtypereference_wrapper.cpp
 ${CMAKE_CURRENT_BINARY_DIR}/sample/oddbooluser_wrapper.cpp
@@ -76,6 +77,7 @@
 ${CMAKE_CURRENT_BINARY_DIR}/sample/str_wrapper.cpp
 ${CMAKE_CURRENT_BINARY_DIR}/sample/strlist_wrapper.cpp
 ${CMAKE_CURRENT_BINARY_DIR}/sample/time_wrapper.cpp
+${CMAKE_CURRENT_BINARY_DIR}/sample/unremovednamespace_wrapper.cpp
 ${CMAKE_CURRENT_BINARY_DIR}/sample/virtualdaughter_wrapper.cpp
 ${CMAKE_CURRENT_BINARY_DIR}/sample/virtualdtor_wrapper.cpp
 ${CMAKE_CURRENT_BINARY_DIR}/sample/virtualmethods_wrapper.cpp

=== debian/changelog ===
shiboken (1.0.0-2maemo1~beta3) unstable; urgency=low

  * New version from upstream

 -- Bruno Araujo <bruno.araujo@openbossa.org>  Tue, 11 Jan 2011 08:54:04 -0400

=== debian/control ===
Source: shiboken
Section: devel
Priority: extra
Maintainer: PyMaemo Team <pymaemo-developers@garage.maemo.org>
XSBC-Original-Maintainer: Debian Python Modules Team <python-modules-team@lists.alioth.debian.org>
Build-Depends: dpkg-dev (>= 1.14.25), debhelper7 (>= 7.3.12), cmake (>= 2.6.0),
	libqt4-dev (>= 4.5.0), libapiextractor-dev (>= 0.9.1-1maemo1), generatorrunner (>= 0.6.3-1maemo1), libgenrunner-dev (>= 0.6.3-1maemo1),
	python-all-dev, python-all-dbg, quilt
XS-Python-Version: >= 2.5
Standards-Version: 3.8.4
Vcs-Svn: svn://svn.debian.org/python-modules/packages/shiboken/trunk/
Vcs-Browser: http://svn.debian.org/wsvn/python-modules/packages/shiboken/?op=log
Homepage: http://www.pyside.org/

Package: shiboken
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, generatorrunner (>= 0.6.3-1maemo1)
Description: CPython bindings generator for C++ libraries
 Shiboken is a bindings generator for C++ libraries that outputs CPython
 source code. It uses generatorrunner and apiextractor to collect information
 from library headers, merging modifications and handwritten code defined in the
 typesystem description.
 .
 Shiboken is the binding generator used to create the PySide bindings.

Package: libshiboken1.0
Section: libs
Architecture: any
Conflicts: libshiboken0 (<< 1.0)
Replaces: libshiboken0 (<< 1.0)
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: CPython bindings generator for C++ libraries - shared library
 Shiboken is a bindings generator for C++ libraries that outputs CPython
 source code. It uses generatorrunner and apiextractor to collect information
 from library headers, merging modifications and handwritten code defined in the
 typesystem description.
 .
 This is the shared library used by shiboken.

Package: libshiboken-dev
Section: libdevel
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libshiboken1.0 (= ${binary:Version})
Description: development files for the shiboken bindings generator library
 Shiboken is a bindings generator for C++ libraries that outputs CPython
 source code. It uses generatorrunner and apiextractor to collect information
 from library headers, merging modifications and handwritten code defined in the
 typesystem description.
 .
 This package contains the development files for the library.

Package: shiboken-dbg
Section: debug
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
         libshiboken1.0 (= ${binary:Version}),
         shiboken (= ${binary:Version})
Description: debugging symbols for shiboken and its library
 Shiboken is a bindings generator for C++ libraries that outputs CPython
 source code. It uses generatorrunner and apiextractor to collect information
 from library headers, merging modifications and handwritten code defined in the
 typesystem description.
 .
 This package contains the debugging symbols for shiboken and libshiboken0.

## shiboken 1.0.0-2maemo1~beta4

=== CMakeLists.txt ===
--- 
+++ 
@@ -70,6 +70,16 @@
     OUTPUT_VARIABLE PY_DEBUG
     OUTPUT_STRIP_TRAILING_WHITESPACE)
 
+
+execute_process(
+    COMMAND ${PYTHON_EXECUTABLE} -c "import sys; \\
+        from distutils import sysconfig; \\
+        vr = sys.version_info; \\
+        suffix = '-dbg' if bool(sysconfig.get_config_var('Py_DEBUG')) else ''; \\
+        print 'python%d.%d%s' % (vr[0], vr[1], suffix)"
+    OUTPUT_VARIABLE PYTHON_BASENAME
+    OUTPUT_STRIP_TRAILING_WHITESPACE)
+
 set(SHIBOKEN_BUILD_TYPE "Release")
 if(CMAKE_BUILD_TYPE STREQUAL "Debug")
     if(NOT PYTHON_DEBUG_LIBRARIES)

=== data/CMakeLists.txt ===
if (CMAKE_BUILD_TYPE STREQUAL "Debug")
    set(LIBRARY_OUTPUT_SUFFIX ${CMAKE_DEBUG_POSTFIX})
else()
    set(LIBRARY_OUTPUT_SUFFIX ${CMAKE_RELEASE_POSTFIX})
endif()

configure_file("${CMAKE_CURRENT_SOURCE_DIR}/ShibokenConfig.cmake.in"
               "${CMAKE_CURRENT_BINARY_DIR}/ShibokenConfig.cmake" @ONLY)
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/ShibokenConfig-spec.cmake.in"
               "${CMAKE_CURRENT_BINARY_DIR}/ShibokenConfig-${PYTHON_BASENAME}.cmake" @ONLY)
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/ShibokenConfigVersion.cmake.in"
               "${CMAKE_CURRENT_BINARY_DIR}/ShibokenConfigVersion.cmake" @ONLY)
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/shiboken.pc.in"
               "${CMAKE_CURRENT_BINARY_DIR}/shiboken${shiboken_SUFFIX}.pc" @ONLY)

install(FILES "${CMAKE_CURRENT_BINARY_DIR}/ShibokenConfig.cmake"
        DESTINATION "${LIB_INSTALL_DIR}/cmake/Shiboken-${shiboken_VERSION}")
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/ShibokenConfig-${PYTHON_BASENAME}.cmake"
        DESTINATION "${LIB_INSTALL_DIR}/cmake/Shiboken-${shiboken_VERSION}")
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/ShibokenConfigVersion.cmake"
        DESTINATION "${LIB_INSTALL_DIR}/cmake/Shiboken-${shiboken_VERSION}")
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/shiboken${shiboken_SUFFIX}.pc"
        DESTINATION "${LIB_INSTALL_DIR}/pkgconfig")

=== generator/CMakeLists.txt ===
project(generators)

set(shiboken_SRC
cppgenerator.cpp
headergenerator.cpp
overloaddata.cpp
shiboken.cpp
shibokengenerator.cpp
shibokennormalize.cpp
)

include_directories(${CMAKE_CURRENT_SOURCE_DIR}
                    ${APIEXTRACTOR_INCLUDE_DIR}
                    ${GENERATORRUNNER_INCLUDE_DIR}
                    ${QT_INCLUDE_DIR}
                    ${QT_QTCORE_INCLUDE_DIR})

add_library(shiboken_generator SHARED ${shiboken_SRC})
set_property(TARGET shiboken_generator PROPERTY PREFIX "")

target_link_libraries(shiboken_generator
                      ${APIEXTRACTOR_LIBRARY}
                      ${GENERATORRUNNER_LIBRARY}
                      ${QT_QTCORE_LIBRARY})

add_executable(shiboken main.cpp)
set_target_properties(shiboken PROPERTIES OUTPUT_NAME shiboken${shiboken_SUFFIX})
target_link_libraries(shiboken ${QT_QTCORE_LIBRARY})

add_dependencies(shiboken shiboken_generator)

install(TARGETS shiboken_generator DESTINATION "${GENERATORRUNNER_PLUGIN_DIR}")
install(TARGETS shiboken DESTINATION bin)

=== libshiboken/CMakeLists.txt ===
--- 
+++ 
@@ -36,7 +36,7 @@
                     ${SPARSEHASH_INCLUDE_PATH})
 add_library(libshiboken SHARED ${libshiboken_SRC})
 target_link_libraries(libshiboken ${SBK_PYTHON_LIBRARIES})
-set_target_properties(libshiboken PROPERTIES OUTPUT_NAME "shiboken${shiboken_SUFFIX}"
+set_target_properties(libshiboken PROPERTIES OUTPUT_NAME "shiboken${shiboken_SUFFIX}-${PYTHON_BASENAME}"
                                              VERSION ${libshiboken_VERSION}
                                              SOVERSION ${libshiboken_SOVERSION}
                                              DEFINE_SYMBOL LIBSHIBOKEN_EXPORTS)

=== tests/samplebinding/CMakeLists.txt ===
--- 
+++ 
@@ -16,6 +16,7 @@
 ${CMAKE_CURRENT_BINARY_DIR}/sample/blackbox_wrapper.cpp
 ${CMAKE_CURRENT_BINARY_DIR}/sample/bucket_wrapper.cpp
 ${CMAKE_CURRENT_BINARY_DIR}/sample/collector_wrapper.cpp
+${CMAKE_CURRENT_BINARY_DIR}/sample/color_wrapper.cpp
 ${CMAKE_CURRENT_BINARY_DIR}/sample/ctorconvrule_wrapper.cpp
 ${CMAKE_CURRENT_BINARY_DIR}/sample/sbkdate_wrapper.cpp
 ${CMAKE_CURRENT_BINARY_DIR}/sample/derived_wrapper.cpp
@@ -51,6 +52,7 @@
 ${CMAKE_CURRENT_BINARY_DIR}/sample/oddbooluser_wrapper.cpp
 ${CMAKE_CURRENT_BINARY_DIR}/sample/overload_wrapper.cpp
 ${CMAKE_CURRENT_BINARY_DIR}/sample/pairuser_wrapper.cpp
+${CMAKE_CURRENT_BINARY_DIR}/sample/pen_wrapper.cpp
 ${CMAKE_CURRENT_BINARY_DIR}/sample/point_wrapper.cpp
 ${CMAKE_CURRENT_BINARY_DIR}/sample/pointf_wrapper.cpp
 ${CMAKE_CURRENT_BINARY_DIR}/sample/pointerholder_wrapper.cpp

=== debian/changelog ===
shiboken (1.0.0-2maemo1~beta4) unstable; urgency=low

  * New version from upstream
  * Port Debian packaging from PPA (1.0.0~beta4-0pyside2)
    + Updated for the new files naming scheme
    + Add copyright notice for sparsehash
  * Drop deprecated patches:
    + allowMultipleShibokenVersions.patch
  * New patch:
    + cmake_selectDefaultPython.patch

 -- Bruno Araujo <bruno.araujo@openbossa.org>  Fri, 28 Jan 2011 14:27:34 -0400

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: PyMaemo Team <pymaemo-developers@garage.maemo.org>
 XSBC-Original-Maintainer: Debian Python Modules Team <python-modules-team@lists.alioth.debian.org>
 Build-Depends: dpkg-dev (>= 1.14.25), debhelper7 (>= 7.3.12), cmake (>= 2.6.0),
-	libqt4-dev (>= 4.5.0), libapiextractor-dev (>= 0.9.1-1maemo1), generatorrunner (>= 0.6.3-1maemo1), libgenrunner-dev (>= 0.6.3-1maemo1),
+	libqt4-dev (>= 4.5.0), libapiextractor-dev (>= 0.9.3-1maemo1), generatorrunner (>= 0.6.4-1maemo1), libgenrunner-dev (>= 0.6.4-1maemo1),
 	python-all-dev, python-all-dbg, quilt
 XS-Python-Version: >= 2.5
 Standards-Version: 3.8.4
@@ -14,7 +14,7 @@
 
 Package: shiboken
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, generatorrunner (>= 0.6.3-1maemo1)
+Depends: ${shlibs:Depends}, ${misc:Depends}, generatorrunner (>= 0.6.4-1maemo1)
 Description: CPython bindings generator for C++ libraries
  Shiboken is a bindings generator for C++ libraries that outputs CPython
  source code. It uses generatorrunner and apiextractor to collect information
@@ -52,6 +52,7 @@
 Package: shiboken-dbg
 Section: debug
 Architecture: any
+Priority: extra
 Depends: ${shlibs:Depends}, ${misc:Depends},
          libshiboken1.0 (= ${binary:Version}),
          shiboken (= ${binary:Version})

## shiboken 1.0.0-2maemo1~beta5

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-include(icecc.cmake)
+Include(icecc.cmake)
 project(shiboken)
 
 cmake_minimum_required(VERSION 2.6)
@@ -7,8 +7,8 @@
                       ${CMAKE_MODULE_PATH})
 
 find_package(Qt4 4.5.0)
-find_package(ApiExtractor 0.9.0)
-find_package(GeneratorRunner 0.6.3)
+find_package(ApiExtractor 0.9.4 REQUIRED)
+find_package(GeneratorRunner 0.6.5 REQUIRED)
 find_package(PythonLibs)
 find_package(PythonInterpWithDebug)
 
@@ -102,6 +102,12 @@
     set(SBK_PYTHON_LIBRARIES "-undefined dynamic_lookup")
 endif()
 
+if(CMAKE_VERSION VERSION_LESS 2.8)
+    set(SBK_PYTHON_INCLUDE_DIR ${PYTHON_INCLUDE_PATH})
+else()
+    set(SBK_PYTHON_INCLUDE_DIR ${PYTHON_INCLUDE_DIRS})
+endif()
+
 add_subdirectory(libshiboken)
 add_subdirectory(doc)
 
@@ -115,12 +121,6 @@
     endif()
 else()
     message(WARNING "Some dependencies were not found, shiboken generator compilation disabled!")
-endif()
-
-if(CMAKE_VERSION VERSION_LESS 2.8)
-    set(SBK_PYTHON_INCLUDE_DIR ${PYTHON_INCLUDE_PATH})
-else()
-    set(SBK_PYTHON_INCLUDE_DIR ${PYTHON_INCLUDE_DIRS})
 endif()
 
 add_subdirectory(data)

=== tests/CMakeLists.txt ===
add_subdirectory(libsample)
add_subdirectory(libother)


add_subdirectory(samplebinding)
add_subdirectory(otherbinding)

file(GLOB TEST_FILES samplebinding/*_test.py otherbinding/*_test.py)

set(test_blacklist "")

find_package(PythonInterp REQUIRED)
if(NOT CTEST_TESTING_TIMEOUT)
    set(CTEST_TESTING_TIMEOUT 60)
endif()

if(CMAKE_VERSION VERSION_LESS 2.8)
    message("CMake version greater than 2.8 necessary to run tests")
else()
    if(WIN32)
        set(TEST_PYTHONPATH     "${sample_BINARY_DIR};${other_BINARY_DIR}")
        set(TEST_LIBRARY_PATH   "$ENV{PATH};${libsample_BINARY_DIR};${libother_BINARY_DIR};${libshiboken_BINARY_DIR}")
        set(LIBRARY_PATH_VAR    "PATH")
        string(REPLACE "\\" "/" TEST_PYTHONPATH "${TEST_PYTHONPATH}")
        string(REPLACE "\\" "/" TEST_LIBRARY_PATH "${TEST_LIBRARY_PATH}")
        string(REPLACE ";" "\\;" TEST_PYTHONPATH "${TEST_PYTHONPATH}")
        string(REPLACE ";" "\\;" TEST_LIBRARY_PATH "${TEST_LIBRARY_PATH}")
    else()
        set(TEST_PYTHONPATH     "${sample_BINARY_DIR}:${other_BINARY_DIR}")
        set(TEST_LIBRARY_PATH   "$ENV{LD_LIBRARY_PATH}:${libsample_BINARY_DIR}:${libother_BINARY_DIR}:${libshiboken_BINARY_DIR}")
        set(LIBRARY_PATH_VAR    "LD_LIBRARY_PATH")
    endif()

    foreach(test_file ${TEST_FILES})
        string(REGEX MATCH "/([^/]+)_test.py" test_name ${test_file})
        list(FIND test_blacklist ${CMAKE_MATCH_1} expect_fail)
        add_test(${CMAKE_MATCH_1} ${PYTHON_EXECUTABLE} ${test_file})
        set_tests_properties(${CMAKE_MATCH_1} PROPERTIES ENVIRONMENT "PYTHONPATH=${TEST_PYTHONPATH};${LIBRARY_PATH_VAR}=${TEST_LIBRARY_PATH}")
        set_tests_properties(${CMAKE_MATCH_1} PROPERTIES TIMEOUT ${CTEST_TESTING_TIMEOUT})
        if (${expect_fail} GREATER -1)
            set_tests_properties(${CMAKE_MATCH_1} PROPERTIES WILL_FAIL TRUE)
        endif()
    endforeach()
endif()

=== tests/otherbinding/CMakeLists.txt ===
project(other)

set(other_TYPESYSTEM
${CMAKE_CURRENT_SOURCE_DIR}/typesystem_other.xml
)

set(other_SRC
${CMAKE_CURRENT_BINARY_DIR}/other/extendsnoimplicitconversion_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/other/number_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/other/otherderived_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/other/othermultiplederived_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/other/otherobjecttype_wrapper.cpp
${CMAKE_CURRENT_BINARY_DIR}/other/other_module_wrapper.cpp
)


configure_file("${CMAKE_CURRENT_SOURCE_DIR}/other-binding.txt.in"
               "${CMAKE_CURRENT_BINARY_DIR}/other-binding.txt" @ONLY)

add_custom_command(OUTPUT ${other_SRC}
COMMAND ${GENERATORRUNNER_BINARY} --project-file=${CMAKE_CURRENT_BINARY_DIR}/other-binding.txt
WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
COMMENT "Running generator for 'other' test binding..."
)

include_directories(${CMAKE_CURRENT_SOURCE_DIR}
                    ${CMAKE_SOURCE_DIR}
                    ${SBK_PYTHON_INCLUDE_DIR}
                    ${libother_SOURCE_DIR}
                    ${libsample_SOURCE_DIR}
                    ${libsample_SOURCE_DIR}/..
                    ${sample_BINARY_DIR}
                    ${sample_BINARY_DIR}/sample
                    ${libshiboken_SOURCE_DIR})
add_library(other MODULE ${other_SRC})
set_property(TARGET other PROPERTY PREFIX "")
if(WIN32)
    set_property(TARGET other PROPERTY SUFFIX ".pyd")
endif()
target_link_libraries(other
                      libother
                      libsample
                      ${SBK_PYTHON_LIBRARIES}
                      libshiboken)

add_dependencies(other sample shiboken_generator)

=== tests/samplebinding/CMakeLists.txt ===
--- 
+++ 
@@ -51,6 +51,7 @@
 ${CMAKE_CURRENT_BINARY_DIR}/sample/objtypereference_wrapper.cpp
 ${CMAKE_CURRENT_BINARY_DIR}/sample/oddbooluser_wrapper.cpp
 ${CMAKE_CURRENT_BINARY_DIR}/sample/overload_wrapper.cpp
+${CMAKE_CURRENT_BINARY_DIR}/sample/overload2_wrapper.cpp
 ${CMAKE_CURRENT_BINARY_DIR}/sample/pairuser_wrapper.cpp
 ${CMAKE_CURRENT_BINARY_DIR}/sample/pen_wrapper.cpp
 ${CMAKE_CURRENT_BINARY_DIR}/sample/point_wrapper.cpp
@@ -87,20 +88,18 @@
 ${CMAKE_CURRENT_BINARY_DIR}/sample/valueandvirtual_wrapper.cpp
 )
 
+configure_file("${CMAKE_CURRENT_SOURCE_DIR}/sample-binding.txt.in"
+               "${CMAKE_CURRENT_BINARY_DIR}/sample-binding.txt" @ONLY)
+
 add_custom_command(OUTPUT ${sample_SRC}
-COMMAND ${GENERATORRUNNER_BINARY} --generatorSet=${generators_BINARY_DIR}/shiboken_generator${CMAKE_RELEASE_POSTFIX}${CMAKE_DEBUG_POSTFIX} --enable-parent-ctor-heuristic
-        ${CMAKE_CURRENT_SOURCE_DIR}/global.h
-        --include-paths=${libsample_SOURCE_DIR}
-        --typesystem-paths=${CMAKE_CURRENT_SOURCE_DIR}
-        --output-directory=${CMAKE_CURRENT_BINARY_DIR}
-        ${sample_TYPESYSTEM}
+COMMAND ${GENERATORRUNNER_BINARY} --project-file=${CMAKE_CURRENT_BINARY_DIR}/sample-binding.txt
 WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
-COMMENT "Running generator for test binding..."
+COMMENT "Running generator for 'sample' test binding..."
 )
 
 include_directories(${CMAKE_CURRENT_SOURCE_DIR}
                     ${CMAKE_SOURCE_DIR}
-                    ${PYTHON_INCLUDE_PATH}
+                    ${SBK_PYTHON_INCLUDE_DIR}
                     ${libsample_SOURCE_DIR}
                     ${libshiboken_SOURCE_DIR})
 add_library(sample MODULE ${sample_SRC})

=== debian/changelog ===
shiboken (1.0.0-2maemo1~beta5) unstable; urgency=low

  * New version from upstream.
  * Update build dependencies needed versions.

 -- Bruno Araujo <bruno.araujo@openbossa.org>  Mon,  7 Feb 2011 15:08:07 -0400

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: PyMaemo Team <pymaemo-developers@garage.maemo.org>
 XSBC-Original-Maintainer: Debian Python Modules Team <python-modules-team@lists.alioth.debian.org>
 Build-Depends: dpkg-dev (>= 1.14.25), debhelper7 (>= 7.3.12), cmake (>= 2.6.0),
-	libqt4-dev (>= 4.5.0), libapiextractor-dev (>= 0.9.3-1maemo1), generatorrunner (>= 0.6.4-1maemo1), libgenrunner-dev (>= 0.6.4-1maemo1),
+	libqt4-dev (>= 4.5.0), libapiextractor-dev (>= 0.9.4-1maemo1), generatorrunner (>= 0.6.5-1maemo1), libgenrunner-dev (>= 0.6.5-1maemo1),
 	python-all-dev, python-all-dbg, quilt
 XS-Python-Version: >= 2.5
 Standards-Version: 3.8.4

=== debian/rules ===
#!/usr/bin/make -f

# Allow to find debhelper7 on Maemo
PATH := /usr/bin/dh7:$(PATH)
export PATH

%:
	dh --with quilt --buildsystem=cmake --parallel $@

# Python versions (default is first)
PYVERSIONS=$(shell pyversions -v -r)
DEFAULT_PY=$(shell pyversions -v -d)

# G++ versions
g++-version := $(shell readlink /usr/bin/g++ | sed -e 's/g++-\(.*\)\.\(.*\)/\1\2/')
g++-version-ge-4.5 := $(shell if test $(g++-version) -ge 45; then echo "yes"; else echo "no"; fi)

#### CONFIGURE ####

override_dh_auto_configure: $(PYVERSIONS:%=override_dh_auto_configure_dbg-%) $(PYVERSIONS:%=override_dh_auto_configure-%)

override_dh_auto_configure_dbg-%:
	mkdir -p build-$*-dbg
	dh_auto_configure --builddirectory=build-$*-dbg -- \
	-DCMAKE_BUILD_TYPE:STRING="Debug" \
	-DCMAKE_SKIP_RPATH=true \
	-DCMAKE_USE_PYTHON_VERSION="$*-dbg;$*_d;$*" \

override_dh_auto_configure-%:
	mkdir -p build-$*
	dh_auto_configure --builddirectory=build-$* -- \
	-DCMAKE_BUILD_TYPE:STRING="Release" \
	-DCMAKE_SKIP_RPATH=true \
	-DCMAKE_USE_PYTHON_VERSION=$* \
	-DDEFAULT_PYTHON_BASENAME=python${DEFAULT_PY}

#### BUILD ####

override_dh_auto_build: $(PYVERSIONS:%=override_dh_auto_build_dbg-%) $(PYVERSIONS:%=override_dh_auto_build-%)

override_dh_auto_build_dbg-%:
	dh_auto_build --builddirectory=build-$*-dbg

override_dh_auto_build-%:
	dh_auto_build --builddirectory=build-$*

override_dh_compress:
	dh_compress -X.js

#### INSTALL ####

override_dh_auto_install: $(PYVERSIONS:%=override_dh_auto_install_dbg-%) $(PYVERSIONS:%=override_dh_auto_install-%)

override_dh_auto_install_dbg-%:
	dh_auto_install --builddirectory=build-$*-dbg --destdir=debian/tmp-dbg

override_dh_auto_install-%:
	dh_auto_install --builddirectory=build-$*

#### STRIP ####
override_dh_strip:
	dh_strip --dbg-package=shiboken-dbg --exclude=-dbg.so

#### TEST ####

override_dh_auto_test: $(PYVERSIONS:%=override_dh_auto_test_dbg-%) $(PYVERSIONS:%=override_dh_auto_test-%)

override_dh_auto_test_dbg-%: prepare_debug_test-%
	- dh_auto_test --builddirectory=build-$*-dbg

override_dh_auto_test-%: prepare_test-%
	dh_auto_test --builddirectory=build-$*

prepare_debug_test-%:
	# Prepare the convenience symlinks for the tests
	$(shell ln -s libother-python$*-dbg.so \
	   build-$*-dbg/tests/libother/libother.so )
	$(shell ln -s libsample-python$*-dbg.so \
	   build-$*-dbg/tests/libsample/libsample.so )
	$(shell ln -s other-python$*-dbg.so \
	   build-$*-dbg/tests/otherbinding/other.so )
	$(shell ln -s sample-python$*-dbg.so \
	   build-$*-dbg/tests/samplebinding/sample.so )

prepare_test-%:
	# Prepare the convenience symlinks for the tests
	$(shell ln -s libother-python$*.so \
	   build-$*/tests/libother/libother.so )
	$(shell ln -s libsample-python$*.so \
	   build-$*/tests/libsample/libsample.so )
	$(shell ln -s other-python$*.so \
	   build-$*/tests/otherbinding/other.so )
	$(shell ln -s sample-python$*.so \
	   build-$*/tests/samplebinding/sample.so )

#### CLEAN ####
override_dh_auto_clean:
	rm -rf build-*
	rm -rf debian/tmp-dbg
	rm -f debian/libshiboken1.0.symbols
	rm -f debian/libshiboken1.0.symbols-py*

#### DEBIAN INSTALL ####

override_dh_install: override_dh_install_done

override_dh_install_real:
	# Install the debug variant
	dh_install --sourcedir=debian/tmp-dbg -pshiboken-dbg
	
	# Install the other variants
	dh_install --list-missing --remaining-packages

override_dh_install_done: override_dh_install_real
	# Setup the default version symbolic links
	$(shell ln -sf libshiboken-python${DEFAULT_PY}.so \
	               debian/libshiboken-dev/usr/lib/libshiboken.so )
	$(shell ln -sf libshiboken-python${DEFAULT_PY}-dbg.so \
	               debian/shiboken-dbg/usr/lib/libshiboken-dbg.so )

#### Shared libs ####
override_dh_makeshlibs: $(PYVERSIONS:%=override_dh_makeshlibs-%)
	cat debian/libshiboken1.0.symbols-py* > debian/libshiboken1.0.symbols
	# Package shiboken ships a usr/lib/generatorrunner/*.so plugin. No shared libs in there.
	-dh_makeshlibs -Nshiboken

override_dh_makeshlibs-%:
	echo "libshiboken-python$*.so.1.0 libshiboken1.0 #MINVER#" > debian/libshiboken1.0.symbols-py$*
	cat debian/libshiboken1.0.symbols.pristine >> debian/libshiboken1.0.symbols-py$*
ifeq ($(g++-version-ge-4.5),yes)
	# g++ version is >= 4.5, add related symbols
	sed -e 's|^ _| (ge-g++4.5)_|g' debian/libshiboken1.0.symbols.g++-ge-4.5 >> debian/libshiboken1.0.symbols-py$*
else
	# g++ version is < 4.5, add related symbols
	sed -e 's|^ _| (lt-g++4.5)_|g' debian/libshiboken1.0.symbols.g++-lt-4.5 >> debian/libshiboken1.0.symbols-py$*
endif


#### Docs ####
binary: binary-arch binary-indep;

binary-indep: binary-arch
	dh binary-indep --until dh_auto_build
	dh_auto_build -i --builddirectory=build-$(DEFAULT_PY) -- doc
	dh binary-indep --after dh_auto_build

## shiboken 1.0.0-2maemo1~rc1

=== debian/changelog ===
shiboken (1.0.0-2maemo1~rc1) unstable; urgency=low

  * New version from upstream.
  * Update build dependencies needed versions.

 -- Bruno Araujo <bruno.araujo@openbossa.org>  Mon, 21 Feb 2011 11:04:55 -0400

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: PyMaemo Team <pymaemo-developers@garage.maemo.org>
 XSBC-Original-Maintainer: Debian Python Modules Team <python-modules-team@lists.alioth.debian.org>
 Build-Depends: dpkg-dev (>= 1.14.25), debhelper7 (>= 7.3.12), cmake (>= 2.6.0),
-	libqt4-dev (>= 4.5.0), libapiextractor-dev (>= 0.9.4-1maemo1), generatorrunner (>= 0.6.5-1maemo1), libgenrunner-dev (>= 0.6.5-1maemo1),
+	libqt4-dev (>= 4.5.0), libapiextractor-dev (>= 0.10.0-1maemo1), generatorrunner (>= 0.6.6-1maemo1), libgenrunner-dev (>= 0.6.6-1maemo1),
 	python-all-dev, python-all-dbg, quilt
 XS-Python-Version: >= 2.5
 Standards-Version: 3.8.4

## shiboken 1.0.0-2maemo1

=== debian/changelog ===
shiboken (1.0.0-2maemo1) unstable; urgency=low

  * New version from upstream.
  * Update build dependencies needed versions.

 -- Willer Moreira <willer.moreira@openbossa.org>  Thu, 03 Mar 2011 11:16:10 -0400

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: PyMaemo Team <pymaemo-developers@garage.maemo.org>
 XSBC-Original-Maintainer: Debian Python Modules Team <python-modules-team@lists.alioth.debian.org>
 Build-Depends: dpkg-dev (>= 1.14.25), debhelper7 (>= 7.3.12), cmake (>= 2.6.0),
-	libqt4-dev (>= 4.5.0), libapiextractor-dev (>= 0.10.0-1maemo1), generatorrunner (>= 0.6.6-1maemo1), libgenrunner-dev (>= 0.6.6-1maemo1),
+	libqt4-dev (>= 4.5.0), libapiextractor-dev (>= 0.10.0-1maemo1), generatorrunner (>= 0.6.7-1maemo1), libgenrunner-dev (>= 0.6.7-1maemo1),
 	python-all-dev, python-all-dbg, quilt
 XS-Python-Version: >= 2.5
 Standards-Version: 3.8.4
@@ -14,7 +14,7 @@
 
 Package: shiboken
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, generatorrunner (>= 0.6.4-1maemo1)
+Depends: ${shlibs:Depends}, ${misc:Depends}, generatorrunner (>= 0.6.7-1maemo1)
 Description: CPython bindings generator for C++ libraries
  Shiboken is a bindings generator for C++ libraries that outputs CPython
  source code. It uses generatorrunner and apiextractor to collect information
